'-------------------------------------------------------------------------------------------

'                         Ds18b20

'               

'            (Sasha_1973)  2013

'-------------------------------------------------------------------------------------------

  $regfile = "m8def.dat"       '  
  $crystal = 8000000       ' 1000000  ' 2000000  ' 4000000  ' 8000000
  $framesize = 32
  $hwstack = 40
  $swstack = 16
  $baud = 38400       '4800     '9600     '19200     '38400     '57600     '115000

'----------------     ----------------------------------------
'  $lib "mcsbyte.lbx"
'--------------------       ----------------------

  Config Portb.0 = Output
   Alias Portb.0

'-------------    TIMER2,    ( ) -----------------

'  Config Timer2 = Timer , Async = On , Prescale = 64       '  32768 / 64 / 256 = 0,5  ( TIMER2 = 2   )
'  Const __timer2 = 2
'---------------------------------------------------------------
  Config Timer2 = Timer , Async = On , Prescale = 128       '  32768 / 128 / 256 = 1  ( TIMER2 = 1   )
  Const __timer2 = 1       '      "__timer2"
'      TIMER2,   
  On Timer2 __timer2 Nosave       '      TIMER2

'---------------       ---------------

'  Assr.3 = 1 : Waitms 100       '  - AS2     
'      AS2 (3)   ASSR (ASSR.3),    
' "Powersave" -   .    TIMER2
'  Mcucr = &B10000000                              '      Power Idle
'  Mcucr = &B10110000       '      Power Save

'------------------------------   USART  -------------------------------------

  Config Pind.0 = Input       '   RxD,  UART
  Config Pind.1 = Output       '   TxD,  UART

'------------------------    1Ware  ---------------------------------

  Config 1wire = Portc.0       '     1  Ds18b20
  Config 1wire = Portc.1       '     2  Ds18b20
  Config 1wire = Portc.2       '     3  Ds18b20
  Config 1wire = Portc.3       '     4  Ds18b20
  Config 1wire = Portc.4       '     5  Ds18b20
  Config 1wire = Portc.5       '     6  Ds18b20

  Const __ds18b20 = &H44
  Const __ds18b20 = &HBE
  Const ___ds18b20 = &HCC

  Const __ds18b20 = 2       '   -     Ds18b20
  Const __ds18b20 = 6       '         Ds18b20

'-------------        Ds18b20  -------------

  Dim Temp As Integer       ' *16  HEX 
  Dim _ As Byte
  Dim _ As Byte
  Dim  As Single
  Dim _ As Byte
  Dim _ As Long
  Dim Ds(2) As Byte At Temp Overlay       '     Ds18b20
  Dim ___ As Byte
  Dim _ds18b20(__ds18b20) As Byte
  Dim _ds18b20(__ds18b20) As Single
  Dim __ds18b20(__ds18b20) As Byte

'-------------          ---------------

  Dim  As Byte
  Dim  As Byte
  Dim  As Byte
  Dim _string As String * 2
  Dim _string As String * 2
  Dim _string As String * 2
  Dim __ As Byte
  Dim __timer2 As Byte
  Dim ___ As Byte
  Dim ____usart As Byte
  Dim ___ As Byte
  Dim ___ As Byte

'-----------------------     -----------------------------

  Declare Sub _uart()
  Declare Sub _ds18b20()
  Declare Sub _()
  Declare Sub __()
  Declare Sub __timer2()
  Declare Sub ___ds18b20()

'----------       ----------

   = 12
   = 0
   = 0

  Gosub ___ds18b20
  Waitms 750

'------------------       ----------------------

  Enable Timer2

'-------------------       -------------------------

  Enable Interrupts

'-------------------------------------------------------------------------------------------
'****************************************************************
'------------------------------     -----------------------------------------
  Do
'-----------------------

     If ___ = 1 Then Gosub _ds18b20

     Incr _

     If ____usart = 1 Then Gosub _uart

     Toggle 

     Waitms 1
'-----------------------
    _:
'      sleep
'      Power Idle
      Power Powersave
'-----------------------
  Loop
 End
'-------------------------------------------------------------------------------------------
'****************************************************************

'=================================================

'                                         

'=================================================

'=================================================
'---       ( USART)
'=================================================
  _uart:
'-------------------------------------------------------------------------------------------

'----------------------------     -----------------------------------------

    Print ""
    Print ""
    Print "---------------------------------"
    Print "  - " ;
    Print  ; ":" ;
    If  < 10 Then Print "0" ;
    Print  ; ":";
    If  < 10 Then Print "0" ;
    Print 

'------------      Ds18b20  ---------------

    Print "---------------------------------"
    Print "_: " ; _
    Print "---------------------------------"

'---------------------      -------------------------

    For _ = 1 To __ds18b20

      If _ds18b20(_) = 0 Then
          If _ds18b20(_) < 0 Then
              Print " " ; _ ; " : " ;
              Print Fusing(_ds18b20(_) , "-#.####") ; "C"
            Else
              Print " " ; _ ; " : " ;
              Print Fusing(_ds18b20(_) , "#.####") ; "C"
          End If
        Else
          Print " " ; _ ; " "
      End If

    Next _

    Print "---------------------------------"
    Print ""

'----------------------        ---------------------------
    ____usart = 0
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'      
'=================================================
  _ds18b20:
'-------------------------------------------------------------------------------------------

    _ = 1

    _ = __ds18b20 - 1

    For _ = 0 To _

      1wreset Pinc , _       '   1 
      1wwrite ___ds18b20 , 1 , Pinc , _       '   1 
      1wwrite __ds18b20 , 1 , Pinc , _       '    1 

      If Err = 1 Then
          Incr __ds18b20(_)
          If __ds18b20(_) > __ds18b20 Then
              _ds18b20(_) = 1
          End If
        Else
           _ds18b20(_) = 0
           __ds18b20(_) = 0

           Ds(1) = 1wread(2 , Pinc , _)       '   

           Gosub _       '       1 

           _ds18b20(_) = 
      End If

      Incr _

    Next _


    Gosub ___ds18b20

    ____usart = 1
    ___ = 0
'-------------------------------------------------------------------------------------------
  Return
'=================================================
'    
'=================================================
  _:
'-------------------------------------------------------------------------------------------
     = Temp
    Shift  , Right , 4
'-------------------------------------------------------------------------------------------
  Return
'=================================================
'      Ds18b20
'=================================================
  ___ds18b20:
'-------------------------------------------------------------------------------------------

    _ = __ds18b20 - 1

    For _ = 0 To _

      1wreset Pinc , _       '   1 
      1wwrite ___ds18b20 , 1 , Pinc , _       '   1   
      1wwrite __ds18b20 , 1 , Pinc , _       '   1 

    Next _

'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'    TIMER2,  1  2   ,     TIMER2
'=================================================
  __timer2:
'-------------------------------------------------------------------------------------------
     $asm
'-------------------------------------------------------------------------------------------
'  ,     
'-------------------------------------------------------------------------------------------
      Push R31       '  ,     
      In R31 , Sreg
      Push R31
'-------------------------------------------------------------------------------------------
'------------------     TIMER2  --------------------
'-------------------------------------------------------------------------------------------
      Lds R31 , {__timer2}       '    "__timer2"   "R31",   
      Inc R31       '      "R31"
      sts {__timer2} , R31       '     "R31"   "__timer2"
'------------------
      Andi R31 , __timer2       '      "Const __timer2"
'------------------
      Breq __timer2       '      "Const __timer2",    "__timer2" -- 
      clr R31                                     '      "Const __timer2",  "0"   "R31
      sts {__timer2} , R31       '     "R31"   "__timer2"      
'-------------------------------------------------------------------------------------------
'      "__timer2"
'-------------------------------------------------------------------------------------------
      rcall __       '     
'-------------------------------------------------------------------------------------------
'---------------       ---------------
'-------------------------------------------------------------------------------------------
     __timer2:
      Pop R31
      Out Sreg , R31       '  
      Pop R31
    $end Asm
'-------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'-----------    : ,     ---------
'=================================================
  __:
'-------------------------------------------------------------------------------------------
    Incr        '  

    If  > 59 Then       '  
         = 0 : Goto _       '       
    End If

    Goto _
'----------------------------------------------------
   _:
'----------------------------------------------------
    Incr        '  

    If  > 59 Then       '  
         = 0 : Goto _       '       
    End If

      Goto _
'----------------------------------------------------
    _:
'----------------------------------------------------
      Incr        '  

      If  > 23 Then       '  
           = 0       '   
      End If
'----------------------------------------------------
    _:
'----------------------------------------------------
'      ____usart = 1
      ___ = 0
      ___ = 1       '  ,    
'-------------------------------------------------------------------------------------------
   ___:
'-------------------------------------------------------------------------------------------
  Return
'=================================================
